#ifndef __CHIPINFO_STRUCT_H__
#define __CHIPINFO_STRUCT_H__

#include "firebrand-struct.h"  // load in chip_request_t definition

#define GENERIC_FUNCTION(A) int (* A)( struct _chip_info_t *, chip_request_t *)

typedef struct _chip_info_t {
  int   id;                     /* Unique identifying number */
  char  *name;                  /* Name of particular chip */
  char  *description;           /* Describing this chip */
  int   cident;                 /* chip identifying code */
  int   loc;                    /* Location of the chip on PCB */
  int   addr_lines;             /* Number of address lines */
  int   switches;               /* How to configure the hardware */

  struct {                      /* API for chip operations */
    GENERIC_FUNCTION( isBlank);
    GENERIC_FUNCTION( makeBlank);
    GENERIC_FUNCTION( read);
    GENERIC_FUNCTION( write);
    GENERIC_FUNCTION( test);
    GENERIC_FUNCTION( id);
  } op;

} chip_info_t;

#endif

